﻿using FlatRedBall;
using FlatRedBall.Graphics;

namespace Maze
{
    public abstract class Entity : PositionedObject
    {
        private readonly string _contentManagerName;

        protected Entity(string contentManagerName)
        {
            _contentManagerName = contentManagerName;
        }

        protected string ContentManagerName
        {
            get
            {
                return _contentManagerName;
            }
        }

        public override void Initialize(bool addToManagers)
        {
            if (addToManagers)
            {
                AddToManager(null);
            }
        }

        public virtual void AddToManager(Layer layer)
        {
            // Add the Entity to the SpriteManager
            // so it gets managed properly (velocity, acceleration, attachments, etc.)
            SpriteManager.AddPositionedObject(this);
        }

        public virtual void Activity()
        {
            
        }

        public virtual void Destroy()
        {
            // Remove self from the SpriteManager:
            SpriteManager.RemovePositionedObject(this);
        }
    }
}
