﻿namespace Maze.Events
{
    public abstract class EventBase<TType>
    {
        public delegate void BaseEventHandler(TType eventArgs);

        private static event BaseEventHandler BaseEvent;

        public virtual void Subscribe(BaseEventHandler subscriber)
        {
            BaseEvent += subscriber;
        }

        public virtual void Unsubscribe(BaseEventHandler subscriber)
        {
            BaseEvent -= subscriber;
        }

        public virtual void Publish(TType eventArgs)
        {
            var handler = BaseEvent;
            if (handler != null) handler(eventArgs);
        }
    }
}
