﻿using FlatRedBall;
using FlatRedBall.Graphics;

namespace Maze.Extensions
{
    public static class CameraExtensions
    {
        public static void SetupCamera(this Camera camera)
        {
            camera.UsePixelCoordinates(true, Globals.ViewportWidth, Globals.ViewportHeight);
        }

        public static void EnableCullMode(this Camera camera, bool enabled)
        {
            if (enabled)
            {
                camera.CameraCullMode = CameraCullMode.UnrotatedDownZ;
                return;
            }
            camera.CameraCullMode = CameraCullMode.None;
        }
    }
}
