﻿using System;
using Maze.Models;
using Microsoft.Xna.Framework;

namespace Maze
{
    public static class Globals
    {
        private const int InitialViewportWidth = 1920;
        private const int InitialViewportHeight = 1080;

        public const bool IsFullScreen = true;
        public const bool AllowUserResizing = false;
        public const bool IsMouseVisible = false;
        public const bool IsCollisionsVisible = false;
        public const string WindowTitle = "Maze 1.0";

        public const bool PSMove = true;

        public const string PSMoveServerAddr = "129.241.172.254";
        public const int PSMoveServerPort = 7899;
        public const int PSMoveConnectTimeoutMs = 100;

        static Globals()
        {
            ViewportWidth = InitialViewportWidth;
            ViewportHeight = InitialViewportHeight;

            GameDifficulty = Options.Difficulty.Normal;
        }

        public static Options.Difficulty GameDifficulty
        {
            get;
            set;
        }

        public static int ViewportWidth
        {
            get;
            set;
        }

        public static int ViewportHeight
        {
            get;
            set;
        }

        public static float CenterX
        {
            get
            {
                return ViewportWidth * .5f;
            }
        }

        public static float CenterY
        {
            get
            {
                return ViewportHeight * .5f;
            }
        }

        public static Vector2 CenterOfScreen
        {
            get
            {
                return new Vector2(CenterX, CenterY);
            }
        }

        public static Vector3 CenterOfScreenVector3
        {
            get
            {
                return new Vector3(CenterOfScreen, 0);
            }
        }

        public static Vector3 PositionUsingOffset(Vector2 startingPoint)
        {
            return PositionUsingOffset(startingPoint, Vector2.Zero);
        }

        public static Vector3 PositionUsingOffset(Vector2 startingPoint, Vector2 offset)
        {
            return offset == Vector2.Zero ? new Vector3(startingPoint, 0) : new Vector3(startingPoint + offset, 0);
        }
    }
}
