﻿using Maze.Models;

namespace Maze.Helpers
{
    public static class BallHelper
    {
        public static float GetProperRotation(DirectionHelper.Direction movementDirection, DirectionHelper.CameraAngle cameraAngle)
        {
            float rotation;

            switch (movementDirection)
            {
                case DirectionHelper.Direction.North:
                case DirectionHelper.Direction.South:
                    rotation = 0;
                    break;
                case DirectionHelper.Direction.East:
                    rotation = Ball.MaxRotation;
                    break;
                case DirectionHelper.Direction.West:
                    rotation = -Ball.MaxRotation;
                    break;
                case DirectionHelper.Direction.NorthEast:
                case DirectionHelper.Direction.SouthEast:
                    rotation = Ball.MaxRotation;
                    break;
                case DirectionHelper.Direction.NorthWest:
                case DirectionHelper.Direction.SouthWest:
                    rotation = -Ball.MaxRotation;
                    break;
                default:
                    rotation = 0;
                    break;
            }
            return rotation;
        }

    }
}
