﻿using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;

namespace Maze.Input.Move.Models
{
    public class MoveCollection : ObservableCollection<Move>
    {
        public void PublishInitialCollectionChanged()
        {
            var items = this.ToList();

            var args = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, items, 0);

            OnCollectionChanged(args);
        }

        protected override void InsertItem(int index, Move item)
        {
            var hasMoveId = this.Any(move => move.MoveID == item.MoveID);
            if (hasMoveId) return;

            base.InsertItem(index, item);
        }

        protected override void RemoveItem(int index)
        {
            var item = this[index];
            item.Destroy();

            base.RemoveItem(index);
        }
    }
}
