﻿using Microsoft.Xna.Framework.Input;
using FRBInputManager = FlatRedBall.Input.InputManager;

namespace Maze.Input.Wrapper
{
    public class KeyboardWrapper : PollableInputWrapper
    {
        private const float RotationTick = 1f;

        public override bool IsActive
        {
            get
            {
                return true;
            }
        }

        public override bool HasRotationActivity
        {
            get
            {
                return KeyDown(Keys.Left) || KeyDown(Keys.Right);
            }
        }

        public override float RotationAmount
        {
            get
            {
                if (KeyDown(Keys.Left))
                {
                    return -RotationTick;
                }
                if (KeyDown(Keys.Right))
                {
                    return RotationTick;
                }
                return 0;
            }
        }

        public override bool KeyPushed(Keys key)
        {
            return FRBInputManager.Keyboard.KeyPushed(key);
        }

        public override bool KeyDown(Keys key)
        {
            return FRBInputManager.Keyboard.KeyDown(key);
        }
    }
}
