﻿using FlatRedBall;
using FlatRedBall.Math;
using FlatRedBall.Math.Geometry;

namespace Maze.Models
{
    public class FinishPoints : PositionedObjectList<Finish>
    {
        public SpriteList SpriteList
        {
            get
            {
                var spriteList = new SpriteList();
                foreach (var finish in this)
                {
                    spriteList.Add(finish.Sprite);
                }
                return spriteList;
            }
        }

        public ShapeCollection Collision
        {
            get
            {
                var shapeCollection = new ShapeCollection();
                foreach (var finish in this)
                {
                    shapeCollection.Circles.Add(finish.Collision);
                }
                return shapeCollection;
            }
        }

        public bool CollisionVisible
        {
            set
            {
                Collision.Visible = value;
            }
        }

        public void Destroy()
        {
            for (int i = Count - 1; i > -1; i--)
            {
                this[i].Destroy();
            }
        }
    }
}
