﻿using FlatRedBall;
using FlatRedBall.Graphics;
using Microsoft.Xna.Framework.Graphics;

namespace Maze.Models.Items
{
    public abstract class Item : CollisionEntity
    {
        protected Item(Layer layer, string contentManager) : base(layer, contentManager)
        {
        }

        protected abstract int Points
        {
            get;
        }

        protected void LoadTexture(string textureName)
        {
            var path = @"Content\Game\Items\" + textureName;
            Texture = FlatRedBallServices.Load<Texture2D>(path, ContentManagerName);
        }

        public void HasCollided()
        {
            Game.GetInstance().AddScore(Points);
            Destroy();
        }
    }
}
