﻿namespace Maze.Models
{
    public class LevelPath
    {
        public LevelPath(string name, string path, int levelNumber)
        {
            Name = name;
            Path = path;
            LevelNumber = levelNumber;
        }

        public string Name
        {
            get;
            private set;
        }

        public string Path
        {
            get;
            private set;
        }

        public string CompletePath
        {
            get
            {
                return CreateCompleteLevelPath(Name, Path);
            }
        }

        public int LevelNumber
        {
            get;
            private set;
        }

        public override string ToString()
        {
            return CompletePath;
        }

        private static string CreateCompleteLevelPath(string name, string path)
        {
            var levelPath = name;
            if (path != null)
            {
                levelPath = path + @"\" + levelPath;
            }
            return levelPath;
        }
    }
}
