﻿using FlatRedBall.Math;

namespace Maze.Models.Menu
{
    public class ButtonCollection : PositionedObjectList<Button>
    {

        public Button SelectedButton
        {
            get;
            private set;
        }

        public void SelectButton(int index)
        {
            SelectButton(this[index]);
        }

        public void SelectButton(Button button)
        {
            ClearSelection();
            SelectedButton = button;
            SelectedButton.Selected = true;
        }

        public void ClearSelection()
        {
            foreach (var button in this)
            {
                button.Selected = false;
            }
        }

        public bool CanSelectNextButton()
        {
            var selectedButtonIndex = IndexOf(SelectedButton);

            return Count > (selectedButtonIndex + 1);
        }

        public void SelectNextButton()
        {
            var selectedButtonIndex = IndexOf(SelectedButton);

            if (Count > (selectedButtonIndex + 1))
            {
                SelectButton(selectedButtonIndex + 1);
            }
        }

        public bool CanSelectPreviousButton()
        {
            var selectedButtonIndex = IndexOf(SelectedButton);

            return (selectedButtonIndex - 1) >= 0;
        }

        public void SelectPreviousButton()
        {
            var selectedButtonIndex = IndexOf(SelectedButton);

            if ((selectedButtonIndex - 1) >= 0)
            {
                SelectButton(selectedButtonIndex - 1);
            }
        }
    }
}
