﻿using FlatRedBall;
using FlatRedBall.Graphics;
using FlatRedBall.Math;
using Maze.Extensions;
using Microsoft.Xna.Framework;

namespace Maze.Screens
{
    public class GameCompletedScreen : BaseScreen
    {
        protected PositionedObjectList<Text> Texts;

        public GameCompletedScreen() : base("GameCompleted")
        {
        }

        protected BitmapFont Font
        {
            get;
            set;
        }

        protected Text GameWonText
        {
            get;
            set;
        }

        public override void Initialize(bool addToManagers)
        {
            LoadBackground(@"Menu\Background");

            Texts = new PositionedObjectList<Text>();

            Font = new BitmapFont(
                "Content/Fonts/calibri_48",
                "Content/Fonts/calibri_48.fnt",
                FlatRedBallServices.GlobalContentManager);

            base.Initialize(addToManagers);
        }

        public override void AddToManagers()
        {
            base.AddToManagers();

            InitializeGameWonText(Layer);
        }

        public override void Activity(bool firstTimeCalled)
        {


            base.Activity(firstTimeCalled);
        }

        public override void Destroy()
        {
            TextManager.RemoveText(Texts);

            base.Destroy();
        }

        private void InitializeGameWonText(Layer layer)
        {
            GameWonText = TextManager.AddText("You Won the Game!", layer);
            GameWonText.Font = Font;
            GameWonText.SetPixelPerfectScale(layer);

            GameWonText.Position = new Vector3(Globals.CenterX - GameWonText.TextCenter(), Globals.ViewportHeight - 200, 0);
            GameWonText.Red = 1f;
            GameWonText.Green = 1f;
            GameWonText.Blue = 1f;

            Texts.Add(GameWonText);
        }
    }
}
