using System;
using System.Collections.Generic;
using System.Text;
using FlatRedBall.AI.Pathfinding;
using FlatRedBall.Graphics.Model;

using FlatRedBall.Input;
using FlatRedBall.Utilities;

using FlatRedBall.Instructions;
using FlatRedBall.Math.Splines;
using BitmapFont = FlatRedBall.Graphics.BitmapFont;
using Cursor = FlatRedBall.Gui.Cursor;
using GuiManager = FlatRedBall.Gui.GuiManager;
// Generated Usings
using RiverGame.Screens;
using Matrix = Microsoft.Xna.Framework.Matrix;
using FlatRedBall.Broadcasting;
using RiverGame.Entities;
using FlatRedBall;
using FlatRedBall.Graphics;
using FlatRedBall.Math;

#if XNA4
using Color = Microsoft.Xna.Framework.Color;
#else
using Color = Microsoft.Xna.Framework.Graphics.Color;
#endif

#if FRB_XNA || SILVERLIGHT
using Keys = Microsoft.Xna.Framework.Input.Keys;
using Vector3 = Microsoft.Xna.Framework.Vector3;
using Texture2D = Microsoft.Xna.Framework.Graphics.Texture2D;
#endif

#if FRB_XNA
using Model = Microsoft.Xna.Framework.Graphics.Model;
#endif

namespace RiverGame.Entities
{
	public partial class OkCancel : PositionedObject, IDestroyable, IVisible
	{
        // This is made global so that static lazy-loaded content can access it.
        public static string ContentManagerName
        {
            get;
            set;
        }

		// Generated Fields
#if DEBUG
static bool HasBeenLoadedWithGlobalContentManager = false;
#endif
static object mLockObject = new object();
static bool mHasRegisteredUnload = false;
static bool IsStaticContentLoaded = false;

private RiverGame.Entities.Frame FrameInstance;
private RiverGame.Entities.Button OkButton;
private RiverGame.Entities.Button CancelButton;
private RiverGame.Entities.TextArial MessageLabel;
public string MessageLabelDisplayText
{
	get
	{
		return MessageLabel.DisplayText;
	}
	set
	{
		MessageLabel.DisplayText = value;
	}
}
public event FlatRedBall.Gui.WindowEvent OkClick;
public event FlatRedBall.Gui.WindowEvent CancelClick;
public event EventHandler BeforeVisibleSet;
public event EventHandler AfterVisibleSet;
protected bool mVisible = true;
public virtual bool Visible
{
	get
	{
		return mVisible;
	}
	set
	{
		bool hasChanged = value != mVisible;
		if (BeforeVisibleSet != null)
		{
			BeforeVisibleSet(this, null);
		}
		mVisible = value;
		FrameInstance.Visible = mVisible;
		OkButton.Visible = mVisible;
		CancelButton.Visible = mVisible;
		MessageLabel.Visible = mVisible;
		if (AfterVisibleSet != null)
		{
			AfterVisibleSet(this, null);
		}
	}
}
protected Layer LayerProvidedByContainer = null;

        public OkCancel(string contentManagerName) :
            this(contentManagerName, true)
        {
        }


        public OkCancel(string contentManagerName, bool addToManagers) :
			base()
		{
			// Don't delete this:
            ContentManagerName = contentManagerName;
            InitializeEntity(addToManagers);

		}

		protected virtual void InitializeEntity(bool addToManagers)
		{
			// Generated Initialize
			LoadStaticContent(ContentManagerName);
			FrameInstance = new RiverGame.Entities.Frame(ContentManagerName, false);
			FrameInstance.Name = "FrameInstance";
			OkButton = new RiverGame.Entities.Button(ContentManagerName, false);
			OkButton.Name = "OkButton";
			CancelButton = new RiverGame.Entities.Button(ContentManagerName, false);
			CancelButton.Name = "CancelButton";
			MessageLabel = new RiverGame.Entities.TextArial(ContentManagerName, false);
			MessageLabel.Name = "MessageLabel";
			OkButton.Click += OnOkClickTunnel;
			CancelButton.Click += OnCancelClickTunnel;
			
			PostInitialize();
			if (addToManagers)
			{
				AddToManagers(null);
			}


		}

// Generated AddToManagers
		public virtual void AddToManagers (Layer layerToAddTo)
		{
			LayerProvidedByContainer = layerToAddTo;
			SpriteManager.AddPositionedObject(this);
			AddToManagersBottomUp(layerToAddTo);
			CustomInitialize();
		}

		public virtual void Activity()
		{
			// Generated Activity
			
			FrameInstance.Activity();
			OkButton.Activity();
			CancelButton.Activity();
			MessageLabel.Activity();
			CustomActivity();
			
			// After Custom Activity
		}

		public virtual void Destroy()
		{
			// Generated Destroy
			SpriteManager.RemovePositionedObject(this);
			if (FrameInstance != null)
			{
				FrameInstance.Destroy();
			}
			if (OkButton != null)
			{
				OkButton.Destroy();
			}
			if (CancelButton != null)
			{
				CancelButton.Destroy();
			}
			if (MessageLabel != null)
			{
				MessageLabel.Destroy();
			}
			


			CustomDestroy();
		}

		// Generated Methods
public virtual void PostInitialize ()
{
	Visible = true;
	MessageLabelDisplayText = "Change DisplayText";
	FrameInstance.ScaleX = 96f;
	FrameInstance.ScaleY = 64f;
	OkButton.DisplayText = "OK";
	OkButton.Z = 1f;
	CancelButton.DisplayText = "Cancel";
	CancelButton.Y = -40f;
	CancelButton.Z = 1f;
	MessageLabel.DisplayText = "Change DisplayText";
	MessageLabel.Y = 40f;
	MessageLabel.Z = 1f;
}
public virtual void AddToManagersBottomUp (Layer layerToAddTo)
{
	// We move this back to the origin and unrotate it so that anything attached to it can just use its absolute position
	float oldRotationX = RotationX;
	float oldRotationY = RotationY;
	float oldRotationZ = RotationZ;
	
	float oldX = X;
	float oldY = Y;
	float oldZ = Z;
	
	X = 0;
	Y = 0;
	Z = 0;
	RotationX = 0;
	RotationY = 0;
	RotationZ = 0;
	FrameInstance.AddToManagers(layerToAddTo);
	FrameInstance.ScaleX = 96f;
	FrameInstance.ScaleY = 64f;
	if (FrameInstance.Parent == null)
	{
		FrameInstance.AttachTo(this, true);
	}
	OkButton.AddToManagers(layerToAddTo);
	OkButton.DisplayText = "OK";
	OkButton.Z = 1f;
	if (OkButton.Parent == null)
	{
		OkButton.AttachTo(this, true);
	}
	CancelButton.AddToManagers(layerToAddTo);
	CancelButton.DisplayText = "Cancel";
	CancelButton.Y = -40f;
	CancelButton.Z = 1f;
	if (CancelButton.Parent == null)
	{
		CancelButton.AttachTo(this, true);
	}
	MessageLabel.AddToManagers(layerToAddTo);
	MessageLabel.DisplayText = "Change DisplayText";
	MessageLabel.Y = 40f;
	MessageLabel.Z = 1f;
	if (MessageLabel.Parent == null)
	{
		MessageLabel.AttachTo(this, true);
	}
	X = oldX;
	Y = oldY;
	Z = oldZ;
	RotationX = oldRotationX;
	RotationY = oldRotationY;
	RotationZ = oldRotationZ;
}
public virtual void ConvertToManuallyUpdated ()
{
	this.ForceUpdateDependenciesDeep();
	SpriteManager.ConvertToManuallyUpdated(this);
	FrameInstance.ConvertToManuallyUpdated();
	OkButton.ConvertToManuallyUpdated();
	CancelButton.ConvertToManuallyUpdated();
	MessageLabel.ConvertToManuallyUpdated();
}
public static void LoadStaticContent (string contentManagerName)
{
	ContentManagerName = contentManagerName;
	#if DEBUG
	if (contentManagerName == FlatRedBallServices.GlobalContentManager)
	{
		HasBeenLoadedWithGlobalContentManager = true;
	}
	else if (HasBeenLoadedWithGlobalContentManager)
	{
		throw new Exception("This type has been loaded with a Global content manager, then loaded with a non-global.  This can lead to a lot of bugs");
	}
	#endif
	if (IsStaticContentLoaded == false)
	{
		IsStaticContentLoaded = true;
		lock (mLockObject)
		{
			if (!mHasRegisteredUnload && ContentManagerName != FlatRedBallServices.GlobalContentManager)
			{
				FlatRedBallServices.GetContentManagerByName(ContentManagerName).AddUnloadMethod("OkCancelStaticUnload", UnloadStaticContent);
				mHasRegisteredUnload = true;
			}
		}
		bool registerUnload = false;
		RiverGame.Entities.Frame.LoadStaticContent(contentManagerName);
		RiverGame.Entities.Button.LoadStaticContent(contentManagerName);
		RiverGame.Entities.TextArial.LoadStaticContent(contentManagerName);
		if (registerUnload && ContentManagerName != FlatRedBallServices.GlobalContentManager)
		{
			lock (mLockObject)
			{
				if (!mHasRegisteredUnload && ContentManagerName != FlatRedBallServices.GlobalContentManager)
				{
					FlatRedBallServices.GetContentManagerByName(ContentManagerName).AddUnloadMethod("OkCancelStaticUnload", UnloadStaticContent);
					mHasRegisteredUnload = true;
				}
			}
		}
		CustomLoadStaticContent(contentManagerName);
	}
}
public static void UnloadStaticContent ()
{
	IsStaticContentLoaded = false;
	mHasRegisteredUnload = false;
}
object GetMember (string memberName)
{
	return null;
}

    }
	
	
	// Extra classes
	public static class OkCancelExtensionMethods
	{
		public static void SetVisible (this PositionedObjectList<OkCancel> list, bool value)
		{
			int count = list.Count;
			for (int i = 0; i < count; i++)
			{
				list[i].Visible = value;
			}
		}
	}
	
}
